% Set up sampling time and delay spread\
TS=1/11e6;
%TS=1/110e6;
%TS=1/20e6;
TRMS=200e-9;
n=ceil(10*TRMS/TS);
jj=sqrt(-1);
% Set up channel model
delt0=1-exp(-TS/TRMS);
hk(1)=(randn(1)+jj*randn(1))*sqrt(delt0/2);
for i=1:n
    delt(i)=delt0*exp(-i*TS/TRMS);
    hk(i+1)=(randn(1)+jj*randn(1))*sqrt(delt(i)/2);
end
plot([1:n+1],real(hk),[1:n+1],imag(hk),[1:n+1],abs(hk))
xlabel('Sample Index')
ylabel('Amplitude')
grid
gtext('Magnitude')
gtext('Real')
gtext('Imaginary')